import random as r
import argparse

beg = ["a","e","i","o","u","ba","be","bi","bo","bu","by","y","da","de","di","do","du","dy","fa","fi","fo","fe","fu","ga","ge","gi","go","gu","ka","ke","ki","ko","ku","ky","ma","me","mi","mo","mu","na","ne","ni","no","nu","pa","pe","pi","po","pu","ra","re","ri","ro","ru","ry","sa","se","si","so","su","ta","te","ti","to","tu","ty","wa","we","wi","wo","wy","za","ze","zi","zo","zu","zy"]
mid = beg + ["l","x","n","r"]

def gen_name(length=None, minimum=None, maximum=None):
    if length == None:
        minimum = 3 if minimum == None else minimum
        maximum = 9 if maximum == None else maximum
        lgt = r.randint(maximum,maximum)
    else:
        lgt = length
    morae = []
    while len("".join(morae)) < lgt:
        if len(morae) == 0:
            mora = r.choice(beg)
            morae.append(mora[0].upper() + mora[1:])
        else:
            mora = r.choice(mid)
            if morae[-1] == mora:
                mora = r.choice(mid)
            morae.append(mora)
    return "".join(morae)

class Plot:
    loc1 = ["a friendly","a hostile","a derelict","an airless","a poison-filled/covered","an overgrown","a looted","a burning","a frozen","a haunted","an infested"]
    loc2 = ["asteroid","moon","space station","spaceship","ringworld","Dyson sphere","planet","Space Whale","pocket of folded space","time vortex","Reroll"]
    miss = ["to explore!","to loot everything not bolted down too securely","to find the last group of kobolds who came here","to find a rumored secret weapon","to find a way to break someone else’s secret weapon","to claim this place in the name of the Kobold Empire!","to make friends!","to rediscover lost technology","to find lost magical items","to find and defeat a powerful enemy"]
    prob = ["an Undead Sample Pack (swarm of zombies and skeletons)","a rival band of kobolds","a detachment from the Elf Armada","refugees with parasites. Big parasites","an artificial intelligence bent on multi-world domination","robot spiders","semi-intelligent metal eating slime","a living asteroid that intends to follow the kobolds home like the largest puppy","an old lich that wants everyone to stay off of their “lawn”","elder gods hailing from the dark spaces between the stars","a Flying Brain Monster"]
    pstats = [[0,5,2,6],[3,3,4,4],[4,3,5,4],[2,4,0,0],[4,1,6,3],[3,3,2,4],[0,2,1,5],[2,3,1,6],[5,2,6,3],[6,6,6,6],[2,3,6,1]]
    
    def __init__(self):
        self.loc_desc = Plot.loc1[r.randint(0, len(Plot.loc1)-1)]
        self.location = Plot.loc2[r.randint(0, len(Plot.loc2)-1)]
        self.missIndex = r.randint(0, len(Plot.miss)-1)
        self.oops = r.randint(1,12)
        self.mission = ""
        if self.oops == 12:
            self.mission += "...well, they weren't paying attention, so don't tell them, but they're supposed "
        self.mission += Plot.miss[r.randint(0, len(Plot.miss)-1)]
        self.probIndex = r.randint(0, len(Plot.prob)-1)
        self.problem = Plot.prob[self.probIndex]
        self.problemStats = Plot.pstats[self.probIndex]
        self.secProblem = None
        self.secProbStats = None
        self.thirdProblem = None
        self.thirdProbStats = None
        if self.probIndex in [1,2]:
            self.problem += " led by " + gen_name()
        if self.probIndex in [4,7,8,10]:
            self.problem += " named " + gen_name(minimum=5, maximum=12)
        if self.probIndex == 3:
            self.secProblem = "Parasites"
            self.secProbStats = [3,4,2,3]
        elif self.probIndex == len(Plot.prob) - 1:
            self.secProbIndex =   r.randint(0, len(Plot.prob)-2)
            self.secProblem = Plot.prob[self.secProbIndex]
            self.secProbStats = Plot.pstats[self.secProbIndex]
            if self.secProbIndex == 3:
                self.thirdProblem = "Parasites"
                self.thirdProbStats = [3,4,2,3]
        self.fullProblem = self.problem
        if self.secProblem and self.secProblem != "Parasites":
            self.fullProblem += ", and its minion, " + self.secProblem


class Character:
    def __init__(self):
        self.name = ""
        self.career = ""
        self.stats = []

    def generate(self):
        self.gen_name()
        self.gen_stats()
        self.gen_career()

    def gen_name(self):
        self.name = gen_name()

    def gen_stats(self, n=12):
        if n < 0:
            print("Too few stat points!")
            return [0,0,0,0]
        stats = [0,0,0,0]
        points = n
        slots = [0,1,2,3]
        for _ in range(points):
            tgl = False
            while tgl == False:
                slt = r.choice(slots)
                if slt <= 1:
                    if stats[slt] == 6: continue
                    if stats[slt] == 5 and r.randint(0,1) != 1: continue
                else:
                    if stats[slt] == 6: continue
                    if stats[slt] > 2 and r.randint(0,stats[slt]-2) != 1: continue
                stats[slt] += 1
                tgl = True
        stats[3] = stats[3] + 2
        if stats[3] > 6:
            stats[3] = 6
        stats[2] = stats[2] + 2
        if stats[2] > 6:
            stats[2] = 6
        self.stats = stats

    def gen_career(self):
        self.career = r.choice(["Soldier/Guard","Pilot","Medic","Mechanic","Politician","Spellcaster","Performer","Historian","Spy","Cook","Cartographer","Inventor","Merchant"])

    def print_name(self):
        print(f"Name: {self.name} (Kobold {self.career})")

    def print(self):
        self.print_name()
        print(f"Order: {self.stats[0]}")
        print(f"Chaos: {self.stats[1]}")
        print(f"Brain: {self.stats[2]}")
        print(f"Body: {self.stats[3]}")

class Ship:
    def __init__(self):
        self.name1 = r.choice(["Red","Orange","Yellow","Green","Blue","Violet","Dark","Light","Frenzied","Maniacal","Ancient"])
        self.name2 = r.choice(["Moon","Comet","Star","Saber","World-Eater","Dancer","Looter","Phlogiston","Fireball","Mecha","Raptor"])
        self.gqual = r.choice(["is stealthy & unarmored","is speedy & unarmored","is maneuverable & unarmored","is always repairable","is self-repairing","is flamboyant & speedy","is slow & armored","is flamboyant & armored","is hard to maneuver & armored","has Too Many Weapons!","has a prototype hyperdrive"])
        self.bqual = r.choice(["has an annoying AI","has inconveniently crossed circuits","has an unpredictable power source","drifts to the right","is haunted","was recently 'found' so the kobolds are unused to it","is too cold","has a constant odd smell","its interior design... changes","its water pressure shifts between slow drip and power wash","it leaves a visible smoke trail"])
        self.fullname = f"{self.name1} {self.name2}"

    def print(self):
        print(f"The {self.fullname} {self.gqual}, but {self.bqual}.")
        print()

class Campaign:
    def __init__(self, n=None, makeChars=True):
        n = 6 if n == None else n
        self.ship = Ship()
        self.params = Plot()
        if makeChars:
            self.characters = []
            for _ in range(n):
                c = Character()
                c.generate()
                self.characters.append(c)
        self.art = "an" if self.params.loc_desc in ["A","E","I","O","U"] else "a"


    def print_params(self, endc=""):
        st = ["Order:", "Chaos:", "Brains:", "Body:"]
        print(f"The Kobolds of the {self.ship.fullname} ", end=endc)
        print(f"have been sent out to {self.art} {self.params.loc_desc} {self.params.location} ", end=endc)
        print(f"in order {self.params.mission} ", end=endc)
        print(f"-- but they're challenged by {self.params.fullProblem}!")
        cst = ", ".join([" ".join(y) for y in list(zip(st, [str(x) for x in self.params.problemStats]))])
        print(f"The challenger's stats: {cst}")
        if self.params.secProblem != None:
            mst = ", ".join([" ".join(y) for y in list(zip(st, [str(x) for x in self.params.secProbStats]))])
            if self.params.secProblem == "Parasites":
                print(f"- The parasites' stats: {mst}")
            else:
                print(f"- Its minion's stats: {mst}")
                if self.params.thirdProblem != None:
                    pst = ", ".join([" ".join(y) for y in list(zip(st, [str(x) for x in self.params.thirdProbStats]))])
                    print(f"- - The parasites' stats: {pst}")
        print()
        self.ship.print()

    def print_chars(self):
        print("The kobolds:")
        for k in self.characters:
            k.print()

if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    group = parser.add_mutually_exclusive_group()
    group.add_argument("-c", "--campaign", help="print a full campaign block with N kobolds (default 6)", nargs="?", const=6, type=int, metavar="N")
    group.add_argument("-k", "--kobolds", help="print N kobolds", type=int, nargs="?", const=1, default=1, metavar="N")
    group.add_argument("-n", "--names", help="print N kobolds without stat blocks", nargs="?", const=1, type=int, metavar="N")
    group.add_argument("-p", "--params", help="print only the parameters of a campaign", action="store_true")
    group.add_argument("-s", "--ship", help="print only the ship name and description", action="store_true")
    args = parser.parse_args()
    # print(args)
    if args.campaign:
        cmp = Campaign(args.campaign)
        cmp.print_params()
        cmp.print_chars()
    elif args.params:
        cmp = Campaign(makeChars=False)
        cmp.print_params()
    elif args.ship:
        ship = Ship()
        ship.print()
    elif args.names:
        for _ in range(args.names):
            c = Character()
            c.generate()
            c.print_name()
    else:
        for _ in range(args.kobolds):
            c = Character()
            c.generate()
            c.print()
